 
  #define Version "2020_1002"
 #define PWM_5bits
 // voir PWM_calculs.xls
 //  Duty value : rsolution descend  5 bits at 180KHz  !
 //  mini= 2 => pour 1%
 //  3=> 10%   7=> 25%   14=> 50%   16=> 60%  18=>65%   20=> 75%
 //  24 => 90%  
 //  maxi= 26=> 98%

 
//#define Version "2020_0930"

// test PWM RC2 180KHz !
// effets de bords !!!!  si trop de message => IRP_bit  !
// contourn avec l'usage d'adresse absolue des variables dans la bank 0
// et taille minimal de Buffer1
// choix Keyboard ou ANA pour consigne PWM
// #define Version "2020_0927"


#define With_LCD
#define With_ADC

#define Directory "C:\\_MikroC\\_MesProjets_MikroC\\_16F877_IRDA_Board"
#define Project " 16F877_Irdaboard_Tests_PWM_5b_180Khz_2020.mcppi"
#define Source " _16F877_Irdaboard_Test_PWM_180Khz_5b"
#define EEPROM "16F877_Irdaboard_Test_LCD_RS_Eeeprom.ihex"
#define FOSC " Q 20Mhz"

//  30 mai 2014
// PWM output SINUS apres filtrage !!! on RC2  
// usage de   void UART1_Write_CText(const char *txt);
// sinon probleme avec IRP_bit  gestion bank RAM
//IRP=0 -> Bank 0,1 
//IRP=1 -> Bank 2,3 
// Common 0x170 .. 0x017F 16 bytes
// bank0   0x020  0x07F  96 bytes
// bank1   0x0A0  0x0EF  80 bytes
// bank2   0x120  0x16F  80 bytes
// bank3   0x1A0  0x1EF  80 bytes

// IRDA_schemA.xml  , shemB.xml

// CONFIG   :$2007 : 0x3B7A
// Q=20Mhz

// 16F877_tests_LCD_RS.eed

 // Hardware  
 //ac:Pwm_Sinus
 // Module RS3232    ac:RS232
 // LCD    ac:LCD
 //schema pic16f877              ac:IRDA_schemA
 // partie lcd   ac:IRDA_SchemB
 


#define With_LCD 
#define With_UART     

//#define debug


// Lcd OCULAR OM16241   2 lignes de 16 cars pinout settings
sbit LCD_RS at RA3_bit;
sbit LCD_RW at RA2_bit;
sbit LCD_EN at RA1_bit;
sbit LCD_D7 at RB3_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D4 at RB0_bit;

// Pin direction
sbit LCD_RS_Direction at TRISA3_bit;
sbit LCD_RW_Direction at TRISA2_bit;
sbit LCD_EN_Direction at TRISA1_bit;
sbit LCD_D7_Direction at TRISB3_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D4_Direction at TRISB0_bit;

sbit Reset_MCP2150 at RC0_bit ;
sbit Reset_MCP2150_dir at TRISC.B0 ;

sbit SQA at PORTD.B6;
sbit SQA_dir at TRISD.B6;

sbit LCD_PWR at RD5_bit;     // to power on the LCD
sbit LCD_PWR_direction at TRISD.B5;     // to power on the LCD
//      SW1 MCLR  reset or VPP input
//#define SW2 PORTA.RA5        // Switch2 avec rappel au +5V
//#define SW3 PORTA.RA4        // Switch1 avec rappel au +5V
sbit SW2 at PORTA.B5 ;       // Switch2 avec rappel au +5V
sbit SW3 at PORTA.B4 ;       // Switch1 avec rappel au +5V
sbit SW2_direction at TRISA.B5;
sbit SW3_direction at TRISA.B4;

#define   Led_Verte_D0 RD0_bit
#define   Led_Verte_D1 RD1_bit
#define   Led_Verte_D2 RD2_bit
#define   Led_Verte_D3 RD3_bit
#define   Led_Verte_D4 RD4_bit
#define   Led_Verte_D5 RD5_bit
#define   Led_Verte_D6 RD6_bit
#define   Led_Verte_D7 RD7_bit



#define EEPROM_32K_ADR 0xA0 // EEPROM 24LC256

#define Highest(param) ((char *)&param)[3]
#define Higher(param) ((char *)&param)[2]
#define Hi(param) ((char *)&param)[1]
#define Lo(param) ((char *)&param)[0]


#define EEPROM_32K_ADR 0xA0 // EEPROM 24LC256


#define CLS 12
#define CR 13
#define LF 10
#define BS 8
#define TAB 9
#define BEL 7
 

const code char mesg0[]=" MikroC 7.60. &  Microchip IRDA board1 16F877\r\n";
const code char mesg1[]=" Directory : "Directory"\r\n";
const code char mesg2[]=" Project : "Project"\r\n";
const code char mesg3[]=" Source : "Source"_"Version".c\r\n";
const code char mesg4[]=" Fosc ="FOSC"\r\n";
const code char mesg5[]=" EEPROM : "EEPROM"\r\n";
const code char mesg6[]=" TEST PWM : sortie sur RC2  \r\n";
const code char mesg7[]=" consigne PWM via Keyboard ou potar sur EA0 \r\n";
const code  char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4,mesg5,mesg6,mesg7} absolute 0x0020;


#define MAXLEN1 32
//unsigned char Table[MAXLEN1] absolute 0x01A0;  // into bank3
volatile unsigned char Buffer1[MAXLEN1] absolute 0x30;
unsigned char DutyVal ;       // the PWM value
volatile unsigned char c1;
volatile int Index1,  CptErr,i1;
//volatile int count ;
volatile unsigned int EA0;
char *p1;
char CRam1[18];
unsigned char cx;
unsigned int i,j,k;
//unsigned long L1;
//unsigned int M1;  // ADC0 measure
//int BP1,BP2;
//unsigned char Idx;
//float F1;


volatile struct chbits {   // 8 flags
                 unsigned FrameErr:1;
                 unsigned Over:1;
                 unsigned Elligible:1;
                 unsigned Togle:1;
                 unsigned See:1;
                 unsigned Ready:1;
                 unsigned Full:1;
                 unsigned Duty_Cde_Mode:1;
               }Drapeaux ;




void Lcd_Out(char row, char column, char *text);
void Lcd_Out_Cp(char *text);
void Lcd_Chr_Cp(char out_char);
void Lcd_Cmd(char out_char);

#define Print UART1_Write_Text
void CPrint(const char *txt);
void CRLF1(void);


//---- EEPROM PIC  bytes  ================
unsigned char EEPROM_Lect(unsigned char adrE) ; // lecture a l'adresse adrL
void EEPROM_Ecr(unsigned char adrE,unsigned char car); // ecrit  a l'adresse adrE
void Save_Msg_To_EEPROM(unsigned char * adrx, unsigned char *ptr1);
void PrintOut_Eeprom_Msg(unsigned char PtrE);  //  for 16Fxxxxx

#define  Put_RS   UART1_Write


void Interrupts() iv 0x0004 ics ICS_AUTO
 {
    if ((RCIE_bit==1) && (RCIF_bit==1) )
    {
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       _asm nop;
       RCSTA.CREN = 1 ;
        CptErr++;
       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      _asm nop;
      RCSTA.SPEN= 1 ;
      CptErr++;
      }
      c1=RCREG;
     // optional echo de la reception
     //TXREG=c1;
     if (c1==CR)
      {
      Drapeaux.Full=1;
      PIE1.RCIE=0 ; //interdit IT Reception UART
      Buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        Buffer1[i1]=c1;
        Index1=i1;
        i1++;
       
      }
    }
  /*------ Timer0 --------------
    if ((T0IE_bit)&&(TMR0IF_bit))
      {  
         TMR0IF_bit    = 0;
         TMR0       = 60;         //with  Q=20Mhz  prescaler 1:256 =>   (255-60)*256*0.25   =10035 S   ~10mS
         count++;                  //Increase counter by one
        if (count >= 10)         //Adjust this value for different time (10ms x XX)
        {
         Drapeaux.Elligible=1;  
         count = 0;
         }
      }
   */

 }




//------  EEPROM du PIC18Fx6K22 ---------------

unsigned char EEPROM_Lect(unsigned char AdrE) // lecture a l'adresse adr
{  
     EEADR =(unsigned char) AdrE & 0x00FF;
    //EEADRH =0;
        EECON1.EEPGD=0;     // 0= adressage sur EEPROM , 1=sur flash
      // EECON1.CFGS=0;      // 0= acces data EEPROM
        EECON1.RD=1;        // arme Lecture EEprom
       while( EECON1.RD=1);  // wait RD=0
        return(EEDATA);
}

//void EEPROM_Ecr(unsigned char AdrE,unsigned char car) // ecrit  a l'adresse adrE
void EEPROM_Ecr(unsigned char AdrE,unsigned char car) // ecrit  a l'adresse adrE
{int dr=0;
   if(INTCON.GIE ==1)
   {
   INTCON.GIE =0 ;
    dr=1;
   } 
    while( EECON1.WR==1); 
    EEADR =AdrE ;
    EEDATA=car;   
    EECON1.EEPGD=0;
    EECON1.WREN=1;  
   EECON1.WRERR=0;    
    EECON2=0x55;
    EECON2=0xAA; 
    EECON1.WR=1; 
    // test si fin d'ecriture
   while ( EECON1.WR ==1); 
    // ou rajout delay   
    // Delay_ms(20);
    PIR2.EEIF=0;    // to be sure
    EECON1.WREN=0;  
   if (dr==1)INTCON.GIE =1;
}

void Save_Msg_To_EEPROM(unsigned char adrx, unsigned char * ptr1)
{   while ((*ptr1>0) && (adrx<256))
        {
         EEPROM_Ecr(adrx++,*ptr1++);
         Delay_ms(20);        
         }
}

void _PrintOut_Eeprom_Msg(unsigned char PtrE)
{ unsigned char c;
  do
  {
  c = EEPROM_Lect(PtrE);
  if ( c>0) Put_RS(c);
  PtrE++;
   Delay_ms(20);
  }
  while ((c!=0) && (PtrE<255))  ;
}

void PrintOut_Eeprom_Msg(unsigned char PtrE)
{ unsigned char c;
  do
  {
  c = EEPROM_Read(PtrE);
  if ( c>0) Put_RS(c);
  PtrE++;
   Delay_ms(20);
  }
  while ((c!=0) && (PtrE<255))  ;
}


 // --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source) {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

void CPrint(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}

void CRLF1()
 { UART1_Write(13);
  UART1_Write(10);
  }
  
void Raz_Uart(void)
{
      for (Index1=0;Index1<MAXLEN1;Index1++) Buffer1[Index1]=0;
       Index1=0;
       i1=0;
       Drapeaux.Full=0;
      c1 = RCREG;
      c1=0;
      p1=0;
      RCIE_bit=1;
}

  void ADC_Init()
{
   ADCON0 = 0x81;  // ADON = 1, Channel A.0 select, Fosc/32 select
   ADCON1 = 0x8E;  // 0x8E    port A0 as analog, right justified output
}

unsigned int ADC_Average_of_16_Reading(unsigned char channel)
{
  int i;
  static unsigned int  avg_output=0;
  unsigned int temp=0 ;
  unsigned int RawM=0;
  //unsigned int digital_out[20];  // genere warning IRP_bit ........
  if(channel > 7) return 0;
  ADCON0 &= 0xC7;        // AND= RAZ channel selection
  ADCON0 |= channel<<3; // OR = Set  chanel selection
  Delay_ms(3);
  for(i=0;i<16;i++)
  {
     GO_bit = 1;
     _asm NOP  //  allways one instruction after setting bit GO  (MicroChip recommandation)
      while(GO_bit);  // Wait until conversion gets over
     RawM=(unsigned int) (ADRESH<<8) + ADRESL ;   // Store 10-bit output into a 16-bit variable
     temp=temp+RawM;
     if (Drapeaux.See==1)
     {
      if ((i % 8)==0)
      {
       CRLF1();
        CPrint(" EA0 => ");
        }
      WordToStr(RawM,CRam1);
      Print(CRam1);    UART1_Write(TAB);
     }
     Delay_ms(1);
  }
  avg_output=temp>>4;    // use SHIFT to divide by 16 to avoid use of maths.h
return(avg_output);
}

void Wait_Commande(const char *CDE)
{
  Drapeaux.Ready=0;
  strConstRamCpy(CRam1,CDE);
  while(Drapeaux.Ready==0)
  {  SQA=1;
     Raz_Uart();
     Delay_1sec();
     SQA=0;
     if(Drapeaux.Full==1)
     {
      p1=strstr(Buffer1,CRam1);
      if (p1>0)
      {
        Drapeaux.Ready=1;
        p1=0;
      }
      }
      
   }
   Drapeaux.Ready=0;
 }




void main()
{
  TRISA=0b11110001 ;
  ADCON1=0x8E;      // RA0=Analog other as digital portA   Right justified
  TRISC=0b10111011 ;  // RC2 en sortie pour PWM
  TRISD=0b00000000 ;
  SQA_dir=0;  // RD6
  SQA=0;
  TRISB=0b11110000 ;
  PORTA=0;
  Reset_MCP2150_dir=0 ;   // pour usage de RX interrupt
  SW2_direction=1; //RA5;
  SW3_direction=1; //RA4;
  
  for (Index1=0;Index1<MAXLEN1;Index1++) Buffer1[Index1]=0;
  Index1=0;
  i1=0;
  Drapeaux.Full=0;
  p1=&Buffer1[0];
 
  // Initialize UART module at 19200 bps
  UART1_Init(19200);
  CRLF1();

  CPrint(" Presentation : \r\n");
  for (i=0;i<7;i++)
  {
  CPrint(Messages[i]);
  }
  CRLF1();
  CPrint(" Reset du MCP2150, pour utiliser RX UART\r\n");
  Reset_MCP2150=0;   // reset MCP2150
  CptErr=0;

  //PrintOut_Eeprom_Msg(0); // message deja en eepropm

 // L1=Get_Fosc_kHz();
 // Print("Freq kHz= ");
 // LongToStr(L1, CRam1);
 // Print(CRam1);
 // CRLF1();
  
  #ifdef With_ADC
  CPrint("ADC Init\r\n");
  ADC_Init();
  #endif

  PORTD=0;
  CPrint("Init LCD\r\n");
   // Initialize LCD
   CPrint(" Power On (RD5) and Init LCD\r\n");
   // Initialize LCD
  // RD5 =LCD_PWR voir schema 103-00032 en C2
  LCD_PWR=1;   // RD5 =LCD_PWR voir schema 103-00032 en C2
  Lcd_Init();
//            1234567890123456
  Lcd_Cmd(_LCD_FIRST_ROW );
  strcpy(CRam1,"16F877 IRDAboard"); 
  Lcd_Out_CP(CRam1); 
  Delay_ms(2000);
  Lcd_Cmd(_LCD_SECOND_ROW );
  strcpy(CRam1,"PWM output onRC2");
  Lcd_Out_CP(CRam1);
  Delay_ms(1000);
  CPrint("Init PWM 180Khz  et Duty sur 5bits =50% \r\n");

   TMR2IE_bit=0;
   TMR2IF_bit=0;
   TRISC2_bit=0;   // RC2 PWM output
  // REGISTER 8-1: CCP1CON REGISTER/CCP2CON REGISTER (ADDRESS 17h/1Dh)
   CCP1CON=0x0C;
  //  init detaille
  // CCP1CON.CCP1X=0;   // b5
  // CCP1CON.CCP1Y=0;   // b4
  //bit 3-0 CCPxM3:CCPxM0: CCPx Mode Select bits
  // 11xx = PWM mode
  // CCP1CON.CCP1M3=1;
  // CCP1CON.CCP1M2=1;
  // CCP1CON.CCP1M1=0;
  // CCP1CON.CCP1M0=0;
  //REGISTER 7-1: T2CON: TIMER2 CONTROL REGISTER (ADDRESS 12h)
  //  TOUTPS3 TOUTPS2 TOUTPS1 TOUTPS0 TMR2ON T2CKPS1 T2CKPS0
  //The input clock (FOSC/4) 
  // pass trough a prescale option of 1:1=00, 1:4=01 or 1:16=10, selected by control bits
  // T2CKPS1:T2CKPS0 (T2CON<1:0>).
  // bit 6-3 TOUTPS3:TOUTPS0: Timer2 Output Postscale Select bits  de 1/1=0000  1/16 =1111
  //T2CON = 0b00000100;     // TMR2 ON, postscale 1:1, prescale 1:1
  // Post Scaler Timer2   = 1/1
  //TOUTPS3_bit=0;
  //TOUTPS2_bit=0;
  //TOUTPS1_bit=0;
  //TOUTPS0_bit=0;
  // prescaler Timer2    1/1
  T2CKPS1_bit=0;
  T2CKPS0_bit=0;
  // at 20/ 4 Mhz tick=0,2S    180 Khz => 5.55S  =>  27x0.2=5.4S
  PR2 = 27-1;     // PR2 set to total PWM period of 10 ticks (5.5uS)  at 20Mhz
  DutyVal=14;  // 50%
  CCPR1L=DutyVal;  //PWM1_Set_Duty(DutyVal)
  TMR2ON_bit=1;
 
   j=0;
 //  while(j<100)
 //  {
 //  SQA=1;
 //  Delay_ms(250);
 //  SQA=0;
 //  Delay_ms(250);
  // j++;
  // }

  // for UART interrupt
  Drapeaux.Full=0;
  i1=0;
  Index1=0;
  CREN_bit=1;
  PEIE_bit=1;
  RCIE_bit=1;
  GIE_bit=1;
  Drapeaux.Duty_Cde_Mode=1;
  Drapeaux.See=1;

 // CPrint("Pret pour capture PWM 180KHz sur analyser ?\r\n");
 // Wait_Commande("oui");

  Drapeaux.Duty_Cde_Mode=1;
  Drapeaux.See=1;
  while(1)
  {
    Raz_Uart();
    Delay_1sec();
    if(Drapeaux.Full==1)
    {
      //Reu :Duty= 125
      CPrint("\r\nReu :");
      Print(Buffer1);
      p1=strstr(Buffer1,"Duty=");
      if (p1>0)
      {
        *(p1+7)=0;
        // atoi ou alors :
         k=     ( *(p1+5)-48)*10;
         k= k + ( *(p1+6)-48)*1;
        // k=atoi(p1+5);
         WordToStr(k,CRam1);
         Print(CRam1);
         UART1_Write(TAB);
         if ((k>0) && (k<27))
         {
         DutyVal=(unsigned char)(k & 0x00FF);
         TMR2ON_bit=0;  //PWM1_Stop();
         CCPR1L=DutyVal; //PWM1_Set_Duty(DutyVal);
         TMR2ON_bit=1; //PWM1_Start();
          CPrint(" -> OK \r\n ");
           Drapeaux.Duty_Cde_Mode=0;
         }
         else
         {  WordToStr(k,CRam1);
            CPrint("Bad value : must be >0 and < 27 ");
            Print(CRam1);
            CRLF1();
         }
       }
        p1=strstr(Buffer1,"ANA_ON");
        if (p1>0) 
        {
          Drapeaux.Duty_Cde_Mode=1;
          CPrint("\r\n Duty_Cde_Mode f(EA0)\r\n");
        }
        p1=strstr(Buffer1,"ANA_OFF");
        if (p1>0) 
        {
           Drapeaux.Duty_Cde_Mode=0;
           CPrint("\r\n Duty_Cde_Mode via Keyboard\r\n");
        }
     }
      if ( Drapeaux.Duty_Cde_Mode==1)
      {
        //CRLF1();
         cx= (unsigned char)(EA0 >>5) ;
         if (cx>26)
         { cx=26;
           CPrint("\r\n EA0 Over ! \r\n");
           }
         DutyVal=cx;
         TMR2ON_bit=0;
         CCPR1L=DutyVal;
         TMR2ON_bit=1;
       }
     Lcd_Cmd(_LCD_FIRST_ROW );
     strcpy(CRam1,"Duty Value=     ");
     ByteToStr(DutyVal,CRam1+13);
     *(CRam1+16)=0 ;
     Lcd_Out_CP(CRam1);
     SQA=1;
     CRLF1();
     Print(CRam1);
     CRLF1();
     SQA=0;
      #ifdef With_ADC
      cx=0;
      EA0=ADC_Average_of_16_Reading(cx);    // maxi=1023
      UART1_Write(BEL);
      #endif
     CRLF1();
   }
}
/*
 Presentation :
 MikroC 7.60. &  Microchip IRDA board1 16F877
 Directory : C:\_MikroC\_MesProjets_MikroC\_16F877_IRDA_Board
 Project :  16F877_Irdaboard_Tests_PWM_5b_180Khz_2020.mcppi
 Source :  _16F877_Irdaboard_Test_PWM_180Khz_5b_2020_1002.c
 Fosc = Q 20Mhz
 EEPROM : 16F877_Irdaboard_Test_LCD_RS_Eeeprom.ihex
 TEST PWM : sortie sur RC2

 Reset du MCP2150, pour utiliser RX UART
ADC Init
Init LCD
 Power On (RD5) and Init LCD
Init PWM 180Khz  et Duty sur 5bits =50%
Duty Value=   24

 EA0 =>   773	  773	  773	  773	  773	  773	  773	  773
 EA0 =>   773	  773	  773	  773	  773	  773	  773	  773	<BEL>
Duty Value=   24
 EA0 =>   773	  773	  773	  773	  773	  773	  773	  773
 EA0 =>   773	  772	  773	  773	  773	  773	  773	  773	<BEL>

Duty Value=    8
 EA0 =>   256	  256	  256	  256	  256	  256	  256	  256
 EA0 =>   256	  256	  256	  256	  256	  256	  256	  256	<BEL>

 EA0 =>   164	  163	  163	  163	  163	  158	  158	  150
 EA0 =>   150	  148	  145	  140	  142	  142	  140	  139	<BEL>

Duty Value=    4
 EA0 =>   114	  114	  114	  114	  114	  114	  114	  114
 EA0 =>   114	  114	  115	  115	  115	  115	  115	  115	<BEL>

Duty Value=    3
 EA0 =>   114	  114	  114	  114	  114	  114	  114	  114
 EA0 =>   114	  114	  114	  114	  114	  114	  114	  114	<BEL>

Duty Value=    2
 EA0 =>    77	   77	   77	   77	   77	   77	   77	   77
 EA0 =>    77	   77	   77	   77	   77	   77	   77	   77	<BEL>


0 1 mikroCPIC1618.exe -MSF -DBG -pP16F877 -RA -C -O11110010 -fo20 -EH"^C
C:\_MikroC\_MesProjets_MikroC\_16F877_IRDA_Board\16F877_Irdaboard_Tests_PWM_2020.ihex" -N"^C
C:\_MikroC\_MesProjets_MikroC\_16F877_IRDA_Board\16F877_Irdaboard_Tests_PWM_5b_180Khz_2020.mcppi" -SP"^C
C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"^C
C:\_MikroC\mikroC PRO for PIC\Uses\P16\" -SP"^C
C:\_MikroC\_MesProjets_MikroC\_16F877_IRDA_Board\" -IP"^C
C:\_MikroC\mikroC PRO for PIC\Uses\P16\" "_16F877_Irdaboard_Test_PWM_180Khz_5b_2020_1002.c" "
_Lib_Math.mcl" "
_Lib_MathDouble.mcl" "
_Lib_System.mcl" "
_Lib_Delays.mcl" "
_Lib_CType.mcl" "
_Lib_CString.mcl" "
_Lib_CStdlib.mcl" "
_Lib_CMath.mcl" "
_Lib_Conversions.mcl" "
_Lib_EEPROM.mcl" "
_Lib_UART_c67.mcl" "
_Lib_CF.mcl" "
_Lib_LcdConsts.mcl" "
_Lib_Lcd.mcl"
0 1139 Available RAM: 352 [bytes], Available ROM: 8192 [bytes]
0 122 Compilation Started P16F877.c
618 123 Compiled Successfully P16F877.c
0 122 Compilation Started
_Lib_Delays.c
123 123 Compiled Successfully
_Lib_Delays.c
0 122 Compilation Started _16F877_Irdaboard_Test_PWM_180Khz_5b_2020_1002.c
0 1004 interrupt handler (Interrupts at 0x0004) _16F877_Irdaboard_Test_PWM_180Khz_5b_2020_1002.c
440 1509 Generated baud rate is 19231 bps (error = 0.16 percent) _16F877_Irdaboard_Test_PWM_180Khz_5b_2020_1002.c
632 123 Compiled Successfully _16F877_Irdaboard_Test_PWM_180Khz_5b_2020_1002.c
0 127 All files Compiled in 78 ms
0 1144 Used RAM (bytes): 176 (50%)  Free RAM (bytes): 176 (50%) Used RAM (bytes): 176 (50%)  Free RAM (bytes): 176 (50%)
0 1144 Used ROM (program words): 2609 (32%)  Free ROM (program words): 5583 (68%) Used ROM (program words): 2609 (32%)  Free ROM (program words): 5583 (68%)
0 125 Project Linked Successfully 16F877_Irdaboard_Tests_PWM_5b_180Khz_2020.mcppi
0 128 Linked in 47 ms
0 129 Project '16F877_Irdaboard_Tests_PWM_5b_180Khz_2020.mcppi' completed: 312 ms
0 103 Finished successfully: 02 oct. 2020, 15:20:24 16F877_Irdaboard_Tests_PWM_5b_180Khz_2020.mcppi


*/